/*-----------------------------------------------------
/* YET : Yet Another Column
/*  Oh!X 1990/6-07
// V3.20以降専用
/*-----------------------------------------------------
// お約束部分

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

enum
	FNTSZ=16
	KEY_SPACE=' '
	WX=64
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
int fzenhan
width(WX,,fzenhan)
int xw=1:// 全角１文字の桁数 / zenkaku 1 character columus
if fzenhan then xw=2
int WX2=44:// ゲームで利用する領域の幅

vpriority(TPAGE,SPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_SPAGE+B_GPAGE0)
apage(GPAGE0)
tColorPaletX68(1,&hff0000ff)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt =0	:// タッチエリア数   / the number of touch area

/*-----------------------------------------------------

int doubtEnd
int clearEnd
int chkFlag
int points
dim char doubt(200,1)
dim int levels(19) = {
	+ 300,   600,   900,  1200,  1500,
	+1800,  2100,  2400,  2700,  3000,
	+3500,  4000,  4500,  5000,  5500,
	+6000,  8000, 10000, 15000, 20000
}
int level=0
int tileX,tileY
int tmp
dim int tiles(2)
int keySen
int gameOver
int i
int ch
float wtm=2.00:// 最初のウエイト時間:200*1/100s
/*
sp_init()
sprite_pattern()
sprite_color()
sp_disp(1)
bg_set(0,1,1)

// 音声データ読み込み
int snd_123=a_setPlayData("YET123.mp3")

makeScreen()
hitKey(NO)
setKeys()
/*
while 1
	tileX=16
	tileY=3
	keySen=1
	/*
	sp_halt(YES)
	gameOver=0
	for i=0 to 2
		if bg_getX68(1,tileX,tileY+i)<>256 then {
			/* 表示位置にタイルがあれば終わり
			gameOver=1
			break
		}
		/* 新しいタイル作成
		tiles(i)=int(rnd()*6+2)*256+1
		bg_putX68(1,tileX,tileY+i,tiles(i))
	next
	sp_halt(NO)
	if gameOver then {
		locate(0,0):print "GameOver"
		break
	}
	/*
//int clk1
//int clk=clock()
	// 前のwait時間が残っている状態で再びwaitをかけるとおかしくなる
	wait(wtm,NO)
	kbclr()
	ch=0
	while 1
		if (keySen) then ch=inkey()
		switch ch
//			case KEY_SPACE:// 一時停止
//				hitKey(NO)
//				break
			case '4':// 右
				moveTile(tileX-1)
				break
			case '6':// 左
				moveTile(tileX+1)
				break
			case '5':// 回転
				tmp=tiles(2)
				bg_putX68(1,tileX,tileY+2,tiles(1))
				tiles(2)=tiles(1)
				bg_putX68(1,tileX,tileY+1,tiles(0))
				tiles(1)=tiles(0)
				bg_putX68(1,tileX,tileY,tmp)
				tiles(0)=tmp
				break
			case '2':// 下
				keySen=0
				break
		endswitch
		/*
		/* ウエイト終了、またはタイルの落下処理
		/*
//clk1=clock()
		if wait(-1)=YES or keySen=0 then {
//locate(0,2):print "clock(wait(-1)終了=";clk1-clk:clk=clk1
			sp_halt(YES)
			if bg_getX68(1,tileX,tileY+3)=256 then {
				for i=0 to 2 /* 下にタイルがなければ1つ下へ
					bg_putX68(1,tileX,tileY+i,256)
				next
				tileY=tileY+1
				for i=0 to 2
					bg_putX68(1,tileX,tileY+i,tiles(i))
				next
			}
			sp_halt(NO)
			wait(wtm,NO):/* 再びウエイトをかける
		}
//locate(0,3):print "clock(wait(-1)中=";clk1-clk
		if bg_getX68(1,tileX,tileY+3)<>256 then {
			// ここでbreakするときはwait()の時間が残っている
			break:// 他のブロックに接触したので落下終了
		}
	endwhile
	/* if gameOver then break
	for i=0 to 2
		doubt(i,0)=tileX
		doubt(i,1)=tileY+i
	next
	doubtEnd=2
	repeat
		check()
		chkFlag=erase()
	until chkFlag=0
endwhile

removeKeys()

// 音声バッファー開放
a_end(snd_123)

end
/*
/*-----------------------------------------------------

func moveTile(newx)
int i
	for i=0 to 2
		if bg_getX68(1,newx,tileY+i)<>256 then return()
	next
	sp_halt(YES)
	for i=0 to 2
		bg_putX68(1,tileX,tileY+i,256)
	next
	for i=0 to 2
		bg_putX68(1,newx ,tileY+i,tiles(i))
	next
	sp_halt(NO)
	tileX=newx
endfunc
/*
/*-----------------------------------------------------
/*
func printScore(point;int)
	locate((WX2-14)/2,1):print using "Points %%%%%%";point
endfunc

func makeScreen()
int i
//	fill(0,0,511,511,rgb(0,16,0))
	gColor(0,119,0):fill(0,0,511,511)
	sp_halt(YES)
	bg_fillX68(1,256)
	for i=5 to 26
		bg_putX68(1,11,i,256*8+2)
		bg_putX68(1,21,i,256*8+2)
	next
	for i=11 to 21
		bg_putX68(1,i,26,256*8+2)
	next
	sp_halt(NO)
	tColorX68(7):printScore(0)
endfunc
/*
/*-----------------------------------------------------
/*
func sprite_color()
int i,j
int r,g,b
int cr,cg,cb
dim int colors(17) = {
	+ 0,  0, 15,	/** blue
	+ 0, 10,  0,	/** green
	+ 0, 15, 15,	/** cyan
	+15,  0,  0,	/** red
	+ 8,  0, 15,	/** magenta
	+15, 15,  0		/** yellow
}
int colorBase=0 
	sp_halt(YES)
	for i=1 to 6
		r=i/4
		g=(i mod 4)/2
		b= i mod 2
		for j=0 to 4
			cr=r * (j*4 + colors(colorBase ))
			cg=g * (j*4 + colors(colorBase+1))
			cb=b * (j*4 + colors(colorBase+2))
			sp_color(j+1,rgbX68(cr,cg,cb),i+1)
		next
		colorBase=colorBase+3
		sp_color(6,&h010101ff,i+1)   /* 6は黒
	next
	/* 枠の色作り
	for i=0 to 2
		sp_color(i+1,hsvX68(16,31,i*2+12),8)
	next
	sp_color(4, hsvX68(22,31,22),8)
	for j=0 to 4
		sp_color(j+1,rgbX68(j*4+15,j*4+15,j*4+15),9)
	next
	//
	sp_color(0,0,9):// 消しパターン用の0は透明
	//
	sp_halt(NO)
endfunc
/*
/*-----------------------------------------------------
/*
func sprite_pattern()
	dim char c(255)
	c={
		+15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,
		+15, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,14,
		+15, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6,14,
		+15, 6, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 6,14,
		+15, 6, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 6,14,
		+15, 6, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 6,14,
		+15, 6, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 6,14,
		+15, 6, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6,14,
		+15, 6, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6,14,
		+15, 6, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 6,14,
		+15, 6, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 6,14,
		+15, 6, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 6,14,
		+15, 6, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 6,14,
		+15, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6,14,
		+15, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,14,
		+14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14
	}
	sp_def(1,c)
	c={
		+3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
		+3, 4, 4, 4, 4, 4, 4, 1, 3, 4, 4, 4, 4, 4, 4, 1,
		+3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1,
		+3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1,
		+3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1,
		+3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1,
		+3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1,
		+3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1,
		+3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
		+4, 4, 4, 1, 3, 4, 4, 4, 4, 4, 4, 1, 3, 4, 4, 4,
		+2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2,
		+2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2,
		+2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2,
		+2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2,
		+2, 2, 2, 1, 3, 4, 2, 2, 2, 2, 2, 1, 3, 4, 2, 2,
		+1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 1
	}
	sp_def(2,c)
	c={ /* 消去パターン
		+0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		+0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0,
		+0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0,
		+0, 0, 0, 5, 0, 0, 3, 4, 3, 0, 0, 5, 0, 0, 0, 0,
		+0, 0, 0, 0, 5, 2, 3, 4, 3, 2, 5, 0, 0, 0, 0, 0,
		+0, 0, 0, 0, 2, 3, 4, 5, 4, 3, 2, 0, 0, 0, 0, 0,
		+0, 0, 0, 3, 3, 4, 4, 5, 4, 4, 3, 3, 0, 0, 0, 0,
		+0, 3, 3, 4, 4, 5, 5, 5, 5, 5, 4, 4, 3, 3, 0, 0,
		+0, 0, 0, 3, 3, 4, 4, 5, 4, 4, 3, 3, 0, 0, 0, 0,
		+0, 0, 0, 0, 2, 3, 4, 5, 4, 3, 2, 0, 0, 0, 0, 0,
		+0, 0, 0, 0, 5, 2, 3, 4, 3, 2, 5, 0, 0, 0, 0, 0,
		+0, 0, 0, 5, 0, 0, 3, 4, 3, 0, 0, 5, 0, 0, 0, 0,
		+0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0,
		+0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0,
		+0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		+0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	}
	sp_def(3,c)
endfunc
/*
/*-----------------------------------------------------
/*
func check()
int tmpX, tmpY
int tileColor
int tile, i, j, counter
int tX,tY
	/*
	clearEnd = doubtEnd + 1
	bg_fillX68(0,0)
	for tile=0 to doubtEnd
		tmpX=doubt(tile,0)
		tmpY=doubt(tile,1)
		doubt(tile,0)=0
		doubt(tile,1)=0
		tileColor = bg_getX68(1,tmpX,tmpY)
		/*
		/* 縦のチェック
		/*
		if (bg_getX68(0,tmpX,tmpY) and 1)=0 then {
			i = 0
			while tileColor = bg_getX68(1,tmpX,tmpY+i)
				doubt(clearEnd+i,0) = tmpX
				doubt(clearEnd+i,1) = tmpY+i
				bg_putX68(0,tmpX,tmpY+i,bg_getX68(0,tmpX,tmpY+i) or 1)
				i = i+1
			endwhile
			if i > 2 then clearEnd = clearEnd+i
		}
		/*
		/* 横のチェック
		/*
		if (bg_getX68(0, tmpX, tmpY) and 2) = 0 then {
			tX = tmpX : tY = tmpY
			while tileColor = bg_getX68(1,tX,tY)
				tX = tX - 1
			endwhile
			tX = tX + 1
			i = 0
			while tileColor = bg_getX68(1, tX+i, tY)
				doubt(clearEnd+i,0) = tX+i
				doubt(clearEnd+i,1) = tY
				bg_putX68(0,tX+i,tY,bg_getX68(0,tX+i,tY) or 2)
				i = i+1
			endwhile
			if i > 2 then clearEnd = clearEnd+i
		}
		/* 
		/* 左斜め上のチェック
		/*
		if (bg_getX68(0, tmpX, tmpY) and 4) = 0 then {
			tX = tmpX : tY = tmpY
			while tileColor = bg_getX68(1,tX,tY)
				tX = tX - 1
				tY = tY - 1
			endwhile
			tX = tX + 1
			tY = tY + 1
			i = 0
			while tileColor = bg_getX68(1,tX+i,tY+i)
				doubt(clearEnd+i,0) = tX+i
				doubt(clearEnd+i,1) = tY+i
				bg_putX68(0,tX+i,tY+i,bg_getX68(0,tX+i,tY+i) or 4)
				i=i+1
			endwhile
			if i > 2 then clearEnd = clearEnd+ i
		}
		/*
		/* 右斜め上のチェック
		/*
		if (bg_getX68(0, tmpX, tmpY) and 8) = 0 then {
			tX = tmpX : tY = tmpY
			while tileColor = bg_getX68(1,tX,tY)
				tX = tX + 1
				tY = tY - 1
			endwhile
			tX = tX - 1
			tY = tY + 1
			i = 0
			while tileColor = bg_getX68(1, tX-i, tY+i)
				doubt(clearEnd+i,0) = tX-i
				doubt(clearEnd+i,1) = tY+i
				bg_putX68(0, tX+i,tY+i, bg_getX68(0,tX-i,tY+i) or 8)
				i = i+1
			endwhile
			if i > 2 then clearEnd = clearEnd+i
		}
	next
	clearEnd= clearEnd - 1
endfunc
/*
/*-----------------------------------------------------
/*
func int erase()
int retVal=0
int i, j, btm /* bottom
int tile
int palColor, newColor
int counter = 0
dim int cols(8) = { 0, 0, 0, 0, 0, 0, 0, 0, 0 }
/*
	if clearEnd = doubtEnd then return(0)
	/*
	/* clear tile
	/*
	for i=doubtEnd+1 to clearEnd
		bg_putX68(1,doubt(i,0),doubt(i,1),256*9+3)
		cols(doubt(i,0)-12)=1
		counter = counter + 1
	next
	/*
	if counter > 0 then {
		if counter = 3 then {
			points = points + 65
		} else {
			points = points + counter*20
		}
		printScore(points)
		if points > levels(level) then {
			if level<19 then level=level+1
			wtm=wtm-0.1
			if wtm<0 then wtm=0:// 累積演算誤差があるので念のため
		}
	}
	repeat : until a_stat(snd_123) = 0
	/*
	doubtEnd = -1
	
	a_play(snd_123)
	for i=12 to 20
		if cols(i-12)=0 then continue
		j = 25
		while bg_getX68(1,i,j)<>256*9+3
			j = j - 1
		endwhile
		btm = j
		while j > 2
			tile = bg_getX68(1,i,j)
			if tile = 256 or tile = 256*9+3 then {
				if tile = 256*9+3 then bg_putX68(1,i,j,256)
				j = j - 1
				continue
			}
			bg_putX68(1, i, btm, tile)
			doubtEnd = doubtEnd + 1
			doubt(doubtEnd,0) = i
			doubt(doubtEnd,1) = btm
			bg_putX68(1,i,j,256)
			btm = btm - 1
			j = j - 1
		endwhile
	next
	return(1)
endfunc

//****************************************************************
// 汎用関数
//****************************************************************

func setKeys()
	enum
		XC=3
		YC=2
		K1X=16*4
		K1Y=16*4
	endenum
	if touchallcnt =0 then {
		apage(GPAGE0)
		dim int keys( XC*YC-1)={'4','5','6',0,'2',0}
		dim str disps(XC*YC-1)={"←","↺","→"," ","↓"," "}
		touchallcnt =setTouchKeys(11*16-8,32*16,XC,YC,K1X,K1Y,keys,disps,"Migu-1M-Regular",touchNo)
	}
	return (touchallcnt)
endfunc

//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		resetAllTouchKeys(touchNo,touchallcnt)
		touchallcnt =0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
